Subject: Re: sendfile() broken with 2.6.26 + Apache 2 ?

From: "J. K. Cliburn" <[email-masked]>
Date: Wed, 16 Jul 2008 08:38:52 -0500

Eric Dumazet wrote:
> Ian Jeffray a écrit :
>> Hi Eric,
>>
>> Thanks for directing me to a better list.
>>
>> Further responses below:
>>
>> Eric Dumazet wrote:
>>> CC to netdev where this report might find better answers
>>>
>>> Ian Jeffray a écrit :
>>>> All,
>>>>
>>>> I moved from kernel 2.6.25.4 to 2.6.26 yesterday and observed that
>>>> large files sent via Apache2 are partially corrupt.
>>>>
>>>> This appears to be linked to sendfile() -- disabling the use of
>>>> sendfile in the apache config (EnableSendfile Off) allows it to
>>>> function as normal.

>>>
>>>
>>> What kind of network adapter are you using ? (lspci | grep -i ether)
>>
>> 02:00.0 Ethernet controller: Attansic Technology Corp. L1 Gigabit 
>> Ethernet Adapter (rev b0)
>>
>>
>>> If you disable TCP segmentation offload on this NIC (ethtool -K eth0 
>>> tso off) , is this problem still present ?
>>
>> Wow.  That 'solves' the problem!  Great.
>>
>> Does this therefore point to an attansic driver issue?
>>
> 
> 
> Yes, maybe related to commit 9d90fb1ac9d97da86e24d9ea947bf2a2f333829a
> In this patch, Jay Cliburn enabled TSO by default for atl1 driver.
> 
> This might be a driver problem, or a generic sendfile() problem, I dont 
> know...

I'm currently traveling and unable to delve into this issue and its 
relation to the atl1 driver.  I should be able to look at it this 
weekend when I get back home.

Jay